/*
 * load.c
 *
 *  Created on: 3 oct. 2012
 *      Author: coissac
 */

#include "orgasm.h"

buffer_t *loadIndexedReads(const char *indexname)
{
	buffer_t tmp;
	buffer_t *reads;
	char *indexFileName;
	FILE *index;
	size_t maxsize;

	asprintf(&indexFileName,"%s.ogx",indexname);
	if (indexFileName == NULL)
		FATALERROR("Cannot allocate memory for file name %s",indexname);

	index = fopen(indexFileName,"r");
	if (index == NULL)
		FATALERROR("Cannot open file %s",indexFileName);

	loadGeneralData(&tmp,index);

	free(indexFileName);
	fclose(index);

	maxsize = (tmp.recordSize  + \
			   2 * sizeof(uint32_t)) * tmp.readCount + 48;

	reads = newBuffer(maxsize,tmp.readSize);

	reads->readCount = tmp.readCount;

	asprintf(&indexFileName,"%s.ofx",indexname);
	if (indexFileName == NULL)
		FATALERROR("Cannot allocate memory for file name %s",indexname);

	index = fopen(indexFileName,"r");
	if (index == NULL)
		FATALERROR("Cannot open file %s",indexFileName);

	loadSequences(reads,index);

	fclose(index);
	free(indexFileName);

	asprintf(&indexFileName,"%s.opx",indexname);
	if (indexFileName == NULL)
		FATALERROR("Cannot allocate memory for file name %s",indexname);

	index = fopen(indexFileName,"r");
	if (index == NULL)
		FATALERROR("Cannot open file %s",indexFileName);

	loadPairData(reads,index);

	fclose(index);
	free(indexFileName);

	asprintf(&indexFileName,"%s.orx",indexname);
	if (indexFileName == NULL)
		FATALERROR("Cannot allocate memory for file name %s",indexname);

	index = fopen(indexFileName,"r");
	if (index == NULL)
		FATALERROR("Cannot open file %s",indexFileName);

	fprintf(stderr,"\nLoading reverse index...\n\n");
	loadOrder1(reads,index);
	fprintf(stderr,"Done.\n");

	fclose(index);
	free(indexFileName);

	reads->minword  = tmp.minword;
	reads->suffixidx= tmp.suffixidx;

	fprintf(stderr,"\nFast indexing forward reads...\n\n");
	indexForward(reads);
	fprintf(stderr,"\nFast indexing reverse reads...\n\n");
    indexReverse(reads);
	fprintf(stderr,"Done.\n");

	return reads;
}
